//+------------------------------------------------------------------+
//|                                                           R2.mq4 |
//|                                                   Simba & Malcik |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Simba & Malcik"
#property link      ""

#define MAGICSS  20070204

//---- input parameters
extern int       MovingAverage=1;              // 1 - SMA, 2 - EMA, 3 - HULL, 4 - JMA, 5 - SATL
extern int       MAPeriod=200;
extern int       JMAPhase=0;
extern int       Oscillator=1;                 // 1 - RSI, 2 - JRSX
extern int       OscillatorPeriod=2;
extern int       OscillatorHighLevel=65;
extern int       OscillatorLowLevel=35;
extern int       OscillatorExitHighLevel=75;
extern int       OscillatorExitLowLevel=25;

datetime         LastDay;
int              i;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(LastDay!=Time[0])
     {
      double Trend_Ma,Day1,Day2,Day3;
      if(MovingAverage==1)Trend_Ma=iMA(Symbol(),PERIOD_D1,MAPeriod,0,MODE_SMA,0,1);
      if(MovingAverage==2)Trend_Ma=iMA(Symbol(),PERIOD_D1,MAPeriod,0,MODE_EMA,0,1);
      if(MovingAverage==3)Trend_Ma=iCustom(Symbol(),PERIOD_D1,"HMA",MAPeriod,0,1);
      if(MovingAverage==4)Trend_Ma=iCustom(Symbol(),PERIOD_D1,"JMA",MAPeriod,JMAPhase,0,1);
      if(MovingAverage==5)Trend_Ma=iCustom(Symbol(),PERIOD_D1,"SATL",0,1);
      if(Oscillator==1)
        {
         Day1=iRSI(Symbol(),PERIOD_D1,OscillatorPeriod,0,3);
         Day2=iRSI(Symbol(),PERIOD_D1,OscillatorPeriod,0,2);
         Day3=iRSI(Symbol(),PERIOD_D1,OscillatorPeriod,0,1);
        }
      if(Oscillator==2)
        {
         Day1=iCustom(Symbol(),PERIOD_D1,"JRSX",OscillatorPeriod,0,3);
         Day2=iCustom(Symbol(),PERIOD_D1,"JRSX",OscillatorPeriod,0,2);
         Day3=iCustom(Symbol(),PERIOD_D1,"JRSX",OscillatorPeriod,0,1);
        }

      if ((Close[1]>Trend_Ma)&&(Day1<OscillatorHighLevel)&&(Day2<Day1)&&(Day3<Day2))OrderSend(Symbol(),OP_BUY,1,NormalizeDouble(Ask,4),3,0,0,"R2",MAGICSS,0,Blue);
      if ((Close[1]<Trend_Ma)&&(Day1>OscillatorLowLevel)&&(Day2>Day1)&&(Day3>Day2))OrderSend(Symbol(),OP_SELL,1,NormalizeDouble(Bid,4),3,0,0,"R2",MAGICSS,0,Red);

      if(OrdersTotal()>0)
        {
         if (Close[1]<Trend_Ma || Day3>OscillatorExitHighLevel)
           {
            for(i=0;i<OrdersTotal();i++)
              {
               if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
               if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
                 {
                  if(OrderType()==OP_BUY)OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,4),3,White);
                 }
              }
           }
         if (Close[1]>Trend_Ma || Day3<OscillatorExitLowLevel)
           {
            for(i=0;i<OrdersTotal();i++)
              {
               if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
               if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
                 {
                  if(OrderType()==OP_SELL)OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,4),3,White);
                 }
              }
           }
        }

      LastDay=Time[0];
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+